/*---------------------------------------------------|
| dTree 3 TEST| www.destroydrop.com/javascript/tree/ |
|----------------------------------------------------|
| Copyright (c) 2002-2003 Geir Landr                |
|                                                    |
| This script can be used freely as long as all      |
| copyright messages are intact.                     |
|                                                    |
|----------------------------------------------------|
| This script is not ready.                          |
|---------------------------------------------------*/
var baseURL = "../doc/";

function node(a,i,p,t,u,ti,ta,ic,ico,cb) {
	this.id = i;
	this.pid = p;
	this.text = t;
	this.url = u;
	this.title = ti;
	this.target = ta;
	this.icon = ic;
	this.iconOpen = ico;
//Andargor
	this.checkbox = cb;
	
	this._ai = a;
	this._io = false;
	this._hc = false;
	this._ls = false;
	this._bd = false;
	this._p = null;
};

var dtreeHandler = {
	_sn : null
};

function dtree(o,usecb) {
	this._obj = o;
	this._aNodes = [];
	this._root = new node(-1,-1);
	this._container = null;
	this._rendered = false;
	this._sn = null;
	this._ad = false;
	this._cb = usecb;
	//if (typoeof(usecb) != "undefined") this._cb = usecb;

	this.config = {
		target		: "contents",
		useLines	: true,
		useIcons	: true,
		useSelect	: true,
		imgPath		: 'img/'
	};

	this.icon = {
		root				: 'base.gif',
		folder			: 'folder.gif',
		folderOpen	: 'folderopen.gif',
		node				: 'page.gif',
		empty				: 'empty.gif',
		line				: 'line.gif',
		join				: 'join.gif',
		joinBottom	: 'joinbottom.gif',
		plus				: 'plus.gif',
		plusBottom	: 'plusbottom.gif',
		minus				: 'minus.gif',
		minusBottom	: 'minusbottom.gif',
		nlPlus			: 'nolines_plus.gif',
		nlMinus			: 'nolines_minus.gif'
	};
};

dtree.prototype.add = function(id,pid,text,url,title,target,icon,iconOpen,cb) {
	if (!target) {target = this.config.target; }
	if (url) { url = baseURL + url; }
	this._aNodes[this._aNodes.length] = new node(this._aNodes.length,id,pid,text,url,title,target,icon,iconOpen,cb);

};

dtree.prototype.toString = function() {
	if (document.getElementById) {
		if (!this._rendered) {
			document.write('<div id="dtree' + this._obj +'" class="dtree" style="display:none;"></div>');
			this._container = document.getElementById('dtree' + this._obj);
			this.drawRoot();
			this._container.style.display = 'block';
			this._rendered = true;
		} else alert("It is not allowed to draw the same tree instance more than once.");
	} else document.write("[ dTree | Browser not supported ]");
	return "";
};

dtree.prototype.drawRoot = function() {
	for (var n=0; n<this._aNodes.length; n++) {
		if (this._root.id==this._aNodes[n].pid) {
			this._aNodes[n]._hc = true;
			this.generate(this._aNodes[n]);
			this.drawChildren(this._aNodes[n]);
			break;
		}
	}
};

dtree.prototype.drawChildren = function(node) {
	node._bd = true;
	var test = 0;
	for (var n=0; n<this._aNodes.length; n++) {
		if (this._aNodes[n].pid==node.id) {
			this.setCS(this._aNodes[n]);
			this._aNodes[n]._p = node;
			this.generate(this._aNodes[n]);
			test++;
		}
	}
	return (test>0);
};

dtree.prototype.setCS = function(node) {
	var nLast;
	for (var n=0; n<this._aNodes.length; n++) {
		if (this._aNodes[n].pid == node.id) node._hc = true;
		if (this._aNodes[n].pid == node.pid) nLast = this._aNodes[n].id;
	}
	if (nLast==node.id) node._ls = true;
};

dtree.prototype.generate = function(node) {
	var parent = (node.pid==this._root.id) ? this._container : document.getElementById('d' + this._obj + node.pid);

	var d = document.createElement('div');
	d.id = 'n' + this._obj + node.id;


	var text = document.createTextNode(node.text);

	var url = document.createElement('a');
	if (node.url) {
		url.className= 'node';
		url.href = node.url;
		url.id = 's' + this._obj + node.id;
		if (node.title) url.title = node.title;
		if (node.target) url.target = node.target;
		url.appendChild(text);
	}



	var children = d.cloneNode(true);
	
	//Andargor
	if (this._cb && !node.checkbox) {
		//alert(node._ai);
		var cb = document.createElement('input');
		cb.type = "checkbox";
		if (navigator.appName == "Netscape") {
			cb.style.height = '8px';
			cb.style.width = '8px';
		} else {
			cb.style.height = '16px';
			cb.style.width = '16px';
		}
		cb.name = 'cb' + this._obj + String(node._ai);
		node.checkbox = cb;
		d.appendChild(cb);
		//d.appendChild(document.createElement('br'));
	}

	
	
	if (node.pid != this._root.id) this.indent(node._p, d);

	var icon = document.createElement('img');
	icon.setAttribute('height',18);
	icon.setAttribute('width',18);

	//icon.setAttribute('onmousedown',"javascript:top.startDrag(" + node.id + ");");


	if (node._hc && node.pid != this._root.id) {
		var j = icon.cloneNode(true);
		j.src = (!this.config.useLines) ? this.config.imgPath+this.icon.nlPlus : ((node._ls) ? this.config.imgPath+this.icon.plusBottom : this.config.imgPath+this.icon.plus);
		j.id = 'j' + this._obj + node.id;
		var jurl = document.createElement('a');
		jurl.href = 'javascript:' + this._obj + '.o(' + node._ai + ');';
		jurl.appendChild(j);
		d.appendChild(jurl);
	} else if (node.pid != this._root.id) {
		var j = icon.cloneNode(true);
		j.src = (!this.config.useLines) ? this.config.imgPath+this.icon.empty :
			((node._ls) ? this.config.imgPath+this.icon.joinBottom : this.config.imgPath+this.icon.join);
		d.appendChild(j);
	}

	if (this.config.useIcons) {
		if (!node.icon) node.icon = (this._root.id == node.pid) ? this.config.imgPath+this.icon.root : ((node._hc) ? this.config.imgPath+this.icon.folder : this.config.imgPath+this.icon.node);
		else node.icon = this.config.imgPath+node.icon;
		if (!node.iconOpen) node.iconOpen = (node._hc) ? this.config.imgPath+this.icon.folderOpen : this.config.imgPath+this.icon.node;
		else node.iconOpen = this.config.imgPath+node.iconOpen;
		icon.src = ((node._io) ? node.iconOpen : node.icon)
		icon.id = 'i' + this._obj + node.id;
		//icon.onmousedown = top.startDrag(icon);
		d.appendChild(icon);
	}

	(node.url) ? d.appendChild(url) : d.appendChild(text);
	parent.appendChild(d);

	if (node._hc) {
		children.style.display = (node.pid != this._root.id) ? 'none' : 'block';
		children.id = 'd' + this._obj + node.id;
		parent.appendChild(children);
	}
};

dtree.prototype.indent = function(node, div) {
	if (node.pid != this._root.id) {
		var ind = document.createElement('img');
		ind.src = (node._ls || !this.config.useLines) ? this.config.imgPath+this.icon.empty : this.config.imgPath+this.icon.line;
		if (node._p && node._p.pid != this._root.id && node._p._hc) this.indent(node._p, div);
		div.appendChild(ind);
	}
};

dtree.prototype.o = function(e) {
	var cn = this._aNodes[e];
	if (!cn._bd) this.drawChildren(cn);
	cn._io = !cn._io;
	this.nodeStatus(cn);
// Andargor
	top.nodeOpen(this,e,cn._io);
	//top.setTimeout("top.nodeOpen();",1);
};

dtree.prototype.nodeStatus = function(node) {
	var d = document.getElementById('d' + this._obj + node.id);
	var j = document.getElementById('j' + this._obj + node.id);
	j.src = (this.config.useLines) ?
	((node._io) ? ((node._ls) ? this.config.imgPath+this.icon.minusBottom:this.config.imgPath+this.icon.minus) : ((node._ls)?this.config.imgPath+this.icon.plusBottom : this.config.imgPath+this.icon.plus)):
	((node._io) ? this.config.imgPath+this.icon.nlMinus : this.config.imgPath+this.icon.nlPlus);
	if (this.config.useIcons) {
		var i = document.getElementById('i' + this._obj + node.id);
		if (node._hc) i.src = (node._io) ? node.iconOpen : node.icon;
	}
	d.style.display = (node._io) ? 'block' : 'none';
};

dtree.prototype.s = function() {
	if (dtreeHandler._sn == this.id) return;
	if (dtreeHandler._sn || dtreeHandler._sn == 0) document.getElementById(dtreeHandler._sn).className = 'node';
	document.getElementById(this.id).className = 'nodeSel';
	dtreeHandler._sn = this.id;
};

/*
dtree.prototype.s = function(id) {
	if (this._sn || this._sn == 0) document.getElementById('s' + this._obj + this._sn).className = 'node';
	document.getElementById('s' + this._obj + id).className = 'nodeSel';
	this._sn = id;

}
*/

dtree.prototype.openTo = function(id) {
	for (var n=0; n<this._aNodes.length;n++) {
		if (this._aNodes[n].id == id) {
			this.openTo(this._aNodes[n].pid);
			if (this._aNodes[n]._hc && this._aNodes[n].pid != this._root.id && !this._aNodes[n]._io) this.o(n);
			break;
		}
	}
};

dtree.prototype.openAll = function() {
	if (this._ad) this.oAll();
	else {
		this.drawAll(this._root.id);
		this._ad = true;
	}
};

dtree.prototype.drawAll = function(id) {
	for (var n=0; n<this._aNodes.length;n++) {
		if (this._aNodes[n].pid==id && this._aNodes[n]._hc) {
			if (!this._aNodes[n]._bd)
				if (this.drawChildren(this._aNodes[n])) this.o(this._aNodes[n]._ai);
			this.drawAll(this._aNodes[n].id);
			if (this._aNodes[n]._ls) break;
		}
	}
}

dtree.prototype.oAll = function() {
	for (var n=0; n<this._aNodes.length;n++)
		if (this._aNodes[n]._hc && !this._aNodes[n]._io && this._aNodes[n].pid != this._root.id ) this.o(this._aNodes[n]._ai);
};

dtree.prototype.closeAll = function() {
	for (var n=0; n<this._aNodes.length;n++)
		if (this._aNodes[n]._hc && this._aNodes[n]._io) this.o(this._aNodes[n]._ai);
};

// Andargor
dtree.prototype.setFolderIcon = function(id) {
	for (var n=0; n<this._aNodes.length;n++) {
		if (this._aNodes[n].id == id) {
			this._aNodes[n].icon = this.icon.folder;
			break;
		}
	}
};

dtree.prototype.getChecked = function() {
	var res = new Array();
	
	for (var n=0; n<this._aNodes.length;n++) {
		//alert("HERE :" + n);
		if (this._aNodes[n].checkbox) {
			if (this._aNodes[n].checkbox.checked) res.push(this._aNodes[n]);
		}
	}
	
	return res;
};

dtree.prototype.selectAll = function() {
	var res;
	for (var n=0; n<this._aNodes.length;n++) {
		if (this._aNodes[n].checkbox) {
			this._aNodes[n].checkbox.checked = true;
		}
	}
	
	return res;
};

dtree.prototype.clearAll = function() {
	var res;
	for (var n=0; n<this._aNodes.length;n++) {
		if (this._aNodes[n].checkbox) {
			this._aNodes[n].checkbox.checked = false;
		}
	}
	
	return res;
};

// IE is missing attachEvent
function attachEventHandler(node, evt, fn) {
	if (document.all){
		node.attachEvent("on" + evt, fn);
	} else {
		node.addEventListener(evt, fn, false);
	}
}

